unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, JvExControls, JvInspector;

type
  TMyObject = class(TPersistent)
  private
    FVariantProp: Variant;
  published
    property VariantProp: Variant read FVariantProp write FVariantProp;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    JvInspector1: TJvInspector;
    procedure Button1Click(Sender: TObject);
  private
    FObject: TMyObject;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AfterConstruction; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AfterConstruction;
begin
  inherited;
  JvInspector1.InspectObject := FObject;
end;

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  FObject := TMyObject.Create();
end;

destructor TForm1.Destroy;
begin
  FreeAndNil(FObject);
  inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  sMsg = 'Variant value is "%s"';
begin
  if VarIsNull(FObject.VariantProp) then
    ShowMessageFmt(sMsg, ['Null'])
  else if VarIsEmpty(FObject.VariantProp) then
    ShowMessageFmt(sMsg, ['Empty/Unassinged'])
  else
    ShowMessageFmt(sMsg, [VarToStr(FObject.VariantProp)]);

end;

end.
